# script history: part of Merck distribution
# menu interface modified 8/99 c hastings
# access to pattern checking added 9/99 c hastings
# edited 9/99 c hastings to add access to user prefs

# Copyright (c) 1995 Merck and Co., Inc.
#       Whitehouse Station, NJ USA
#          All Rights Reserved

proc Nv_ShowPeakAnal {args} {
    global Nv_Priv curr_list curr_peak
    set narg [llength $args]
    if {$narg>0} { set nm [lindex $args 0] } else {set nm $Nv_Priv(peakAnal)}
    if {$narg>1} {
        set listName [lindex $args 1]
        set listIdx [lsearch [nv_peak lists] $listName]
        set curr_list ""
        if {$listIdx >= 0} {
            set curr_list $listName
            set curr_peak 0
        }
        
    } else {
        set nm $Nv_Priv(peakAnal)
    }
    if {![winfo exists $nm]} {
        Nv_MkPeakAnal $nm
    }
    NvSetPeakAnal $nm
    wm deiconify $nm
    raise $nm
    update
    NvUpdatePeakAnal $nm
}

proc Nv_MkPeakAnal {nm} {
    
    if {[string range $nm 0 0]!="."} {
        errmsg "Window must start with ."
        return
    }
    
    set varnm [NvVarnm $nm]
    global $varnm Nv_Priv
    
    if {[winfo exists $nm]} {
        raise $nm
        return
    }
    toplevel $nm
    wm title $nm peakPanel
    wm withdraw $nm
    global $varnm Nv_Priv
    upvar #0 $varnm panvar
    
    set panvar(start) 0
    if {[llength [nv_peak lists]] < 1} {
        set panvar(curr_list) ""
        set panvar(curr_peak) -1
    } else {
        set panvar(curr_list) [lindex [nv_peak lists] 0]
        set panvar(curr_peak) 0
    }
    
    frame $nm.mbar -relief raised -bd 2
    frame $nm.fr1 -border 0 -relief flat
    frame $nm.fr2
    frame $nm.fr3
    menubutton $nm.mbar.file -text File -underline 0 \
    -menu $nm.mbar.file.menu
    
    add_tip $nm.mbar.file peakAnal.file "File Menu:\n\n\
    WriteList: Write peak list to an ascii text file.\n\n\
    ReadList: Read a peak list from an ascii text file.\n\n\
    Close: Close Peak Analysis Panel."
    
    
    menubutton $nm.mbar.move -text Move -underline 0 -menu $nm.mbar.move.menu
    
    add_tip $nm.mbar.move peakAnal.move "Move Menu:\n\n First: Jump to first peak in list.\n\n Last: Jump to last peak in list."
    
    menubutton $nm.mbar.edit -text Edit -underline 0 -menu $nm.mbar.edit.menu
    
    add_tip $nm.mbar.edit peakAnal.edit "Edit Menu:\n\n Compress: Compress peak list by permanently removing deleted peaks.\n\n DeleteList: Delete the\
    currently selected peak list.\n\n Reference: Display and edit reference data for this peak list.\n\n Couple: Join peaks that are split by a specified\
    coupling.\n\n Identify: List possible assignments for the current peak.\n\n Get Volumes: Calculate peak volumes for all peaks in the current list.\n\n\
    Get Intensities: Calculate peak intensities for all peaks in the current list.\n\n Plot Volumes vs. Intensites: Show an XY plot of volume vs.\
    intensities for all the peaks in current list."
    
    menubutton $nm.mbar.check -text Check -underline 0 -menu $nm.mbar.check.menu
    
    
    menubutton $nm.mbar.integrate -text Int -underline 0 -menu $nm.mbar.integrate.menu
    
    menubutton $nm.mbar.list -text List -underline 0 -menu $nm.mbar.list.menu
    
    add_tip $nm.mbar.list peakAnal.list "List Menu:\n\n Use this menu to select a peak list to be displayed in this panel."
    
    
    pack $nm.mbar.file $nm.mbar.move $nm.mbar.edit $nm.mbar.check $nm.mbar.integrate $nm.mbar.list -side left -padx 1m -pady 1m
    
    menu $nm.mbar.file.menu -tearoff 0
    $nm.mbar.file.menu add command -label "Write List" -command "NvPeaksWriteList"
    $nm.mbar.file.menu add command -label "Read List" -command "NvGetFile rdpeaks"
    $nm.mbar.file.menu add command -label "Make New List" -command "MkNewlist"
    $nm.mbar.file.menu add command -label "Read All Lists" -command "readallpks"
    $nm.mbar.file.menu add command -label "Write All Lists" -command "writeallpeaks"
    $nm.mbar.file.menu add command -label Close -command "wm withdraw $nm"
    menu $nm.mbar.move.menu -tearoff 0
    $nm.mbar.move.menu add command -label First -command "
    set ${varnm}(curr_peak) 0
    NvUpdatePeakAnal $nm
    "
    $nm.mbar.move.menu add command -label "First Unassigned" -command "gfirstua"
    $nm.mbar.move.menu add command -label "Next Unassigned" -command "gnextua"
    $nm.mbar.move.menu add command -label "First Unlocked" -command "gfirstul"
    $nm.mbar.move.menu add command -label "Next Unlocked" -command "gnextul"
    $nm.mbar.move.menu add command -label Last -command "
    set ${varnm}(curr_peak) 100000
    NvUpdatePeakAnal $nm
    "
    menu $nm.mbar.edit.menu -tearoff 0
    $nm.mbar.edit.menu add command -label Compress -command NvPeakCompress
    $nm.mbar.edit.menu add command -label Degap -command "compact"
    $nm.mbar.edit.menu add command -label "Compress & Degap" -command "compactdel"
    $nm.mbar.edit.menu add command -label DeleteList -command "NvPeakDeleteList \$${varnm}(curr_list)"
    $nm.mbar.edit.menu add command -label Reference -command "Nv_ShowPeakRef $nm"
    $nm.mbar.edit.menu add command -label Couple -command "Nv_ShowPeakCouple $Nv_Priv(peakCouple)"
    $nm.mbar.edit.menu add command -label Cluster -command "nv_peak cluster \$${varnm}(curr_list)"
    $nm.mbar.edit.menu add command -label Fit -command "nv_peak fit \[nv_peak dataset \$${varnm}(curr_list)\] \$${varnm}(curr_list).\$${varnm}(curr_peak)"
    $nm.mbar.edit.menu add command -label Partners -command "NvPeakPartners"
    $nm.mbar.edit.menu add command -label Identify -command "Nv_ShowPeakId $Nv_Priv(peakId)"
    
    menu $nm.mbar.check.menu -tearoff 0
    
    $nm.mbar.check.menu add command -label "Check Pattern" -command "MkCheckPeakPattern .checkPattern"
    $nm.mbar.check.menu add command -label "Check Assignments" -command "MkCheckPeakShifts .checkPeakShifts"
    $nm.mbar.check.menu add command -label "Search Peaks" -command "MkPeakSearch .peakSearch"
    
    
    menu $nm.mbar.integrate.menu -tearoff 0
    $nm.mbar.integrate.menu add command -label "Associate Dataset" -command "NvDatasetAssoc"
    $nm.mbar.integrate.menu add command -label "Get Volumes" -command "
    Nv_PeakVolumes volume
    NvUpdatePeakAnal $nm
    "
    $nm.mbar.integrate.menu add command -label "Get eVolumes" -command "
    Nv_PeakVolumes evolume
    NvUpdatePeakAnal $nm
    "
    $nm.mbar.integrate.menu add command -label "Get Intensities" -command "
    Nv_PeakIntensities center
    NvUpdatePeakAnal $nm
    "
    $nm.mbar.integrate.menu add command -label "Plot Vol vs. Intensities" -command "NvPeakPlotVolInt"
    
    set menu $nm.mbar.list.menu
    menu $menu -postcommand [list NvFillPeakAnalMenu $nm $menu ${varnm}(curr_list) ] ; # everytime this menu is posted refresh the peak sets available
    
    #    scrollbar $nm.fr1.scroll -command "NvUpdatePeakAnal $nm"
    pack $nm.mbar  -fill x -padx 1m -pady 1m -side top
    button $nm.mbar.prev -bitmap @$Nv_Priv(image,down)  -width 20 -command "NvPeakIncr $varnm -1;NvUpdatePeakAnal $nm"
    add_tip $nm.mbar.prev peakAnal.prev "Click this button to go to the previous peak in list."
    
    button $nm.mbar.next -bitmap @$Nv_Priv(image,up) -width 20 -command "NvPeakIncr $varnm 1;NvUpdatePeakAnal $nm"
    add_tip $nm.mbar.next peakAnal.next "Click this button to go to the next peak in list."
    
    bind $nm <Alt-Key-q> "NvPeakFlipStatus $nm"
    bind $nm <Alt-Key-o> "NvPeakIncr $varnm 1;NvUpdatePeakAnal $nm"
    bind $nm <Alt-Key-k> "NvPeakIncr $varnm -1;NvUpdatePeakAnal $nm"
    button $nm.mbar.delstatus -bitmap @$Nv_Priv(image,pirate) -width 20 -command "NvPeakFlipStatus $nm"
    add_tip $nm.mbar.delstatus peakAnal.delstatus "Click this button to delete or undelete the current peak.
    The button will be red if the status of the peak is set to DELETE."
    
    button $nm.mbar.locked -bitmap @$Nv_Priv(image,unlock) -width 20 -command "NvPeakFlipLock $nm"
    add_tip $nm.mbar.locked peakAnal.locked "Click this button to lock or unlock the current peak.
    The button will be red if the status of the peak is set to DELETE."
    
    entry $nm.mbar.peak -width 6  -relief sunken  -textvariable ${varnm}(curr_peak)
    add_tip $nm.mbar.peak peakAnal.peak "The current peak.\n\n  Type in a value and
    hit the Enter key to change it."
    
    bind $nm.mbar.peak <Return> "NvUpdatePeakAnal $nm"
    
    pack $nm.mbar.peak $nm.mbar.prev $nm.mbar.next $nm.mbar.delstatus $nm.mbar.locked -side left
    if {!$Nv_Priv(javaMode)} {
        pack $nm.mbar  -fill x  -side top
        
        pack $nm.fr1  -fill both -side top -expand y
        pack $nm.fr2 -side bottom -fill x
        pack $nm.fr3 -side bottom -fill x
    } else {
        grid $nm.mbar -gridx 0 -gridy 0 -fill x -weightx 1.0 -weighty 0.0
        grid $nm.fr1 -gridx 0 -gridy 1 -fill both -weightx 1.0 -weighty 1.0
        grid $nm.fr2 -gridx 0 -gridy 2 -fill x -weightx 1.0 -weighty 0.0
        grid $nm.fr3 -gridx 0 -gridy 3 -fill x -weightx 1.0 -weighty 0.0
    }
    
    if {!$Nv_Priv(javaMode)} {
        set canvas $nm.fr1.canvas
        canvas $canvas -width 10 -height 10 \
        -yscrollcommand [list $nm.fr1.yscroll set]
        scrollbar $nm.fr1.yscroll -orient vertical \
        -command [list $canvas yview]
        pack $nm.fr1.yscroll -side right -fill y
        pack $canvas -side left -fill both -expand true
        
        set fr $canvas.data
        frame $fr
        $canvas create window 0 0 -anchor nw -window $fr
        
        
    } else {
        set spane $nm.fr1.spane
        #		jscrollpane $spane
        frame $spane
        pack $spane -fill both -expand true
        set fr $nm.fr1.spane.panel
        frame $fr -relief raised -bd 2
        #		$spane jset $fr
        pack $fr -fill both -expand yes
    }
    
    
    
    set  RowNames "Label RName Center Width Bounds J LinkA LinkB Cluster User Error"
    set  RowTypes {.L .R .P .WH .BH .J .a .b .c .U .E}
    set panvar(nRows) [llength $RowNames]
    set nfields 4
    set panvar(nLabels) 1
    set panvar(labelIndex) 0
    for {set row 0 } {$row < [llength $RowNames]} {incr row} {
        set i $row
        set  panvar(Label,$row) [lindex $RowNames $row]
        set  panvar(Type,$row) [lindex $RowTypes $row]
        if {[lindex $RowNames $row]=="Label"} {
            frame $fr.labframe
            label $fr.labframe.lab -text Lab -width 3
            pack $fr.labframe.lab -side left
            label $fr.labframe.labI -textvariable ${varnm}(labelIndex) -width 2
            pack $fr.labframe.labI -side left
            label $fr.labframe.labN -textvariable ${varnm}(nLabels)  -width 2
            pack $fr.labframe.labN -side left
            button $fr.labframe.down -text >  \
            -width 1 -command "NvPeakShiftLabel $nm $fr.$row.0 1"
            button $fr.labframe.up -text <  \
            -width 1 -command "NvPeakShiftLabel $nm $fr.$row.0 -1"
            pack $fr.labframe.up $fr.labframe.down -side left
            if {!$Nv_Priv(javaMode)} {
                grid columnconfigure $fr 0 -weight 100
                grid rowconfigure $fr $i -weight 100
                grid $fr.labframe -in $fr -column 0 -row $i -sticky nsew
            } else {
                grid $fr.labframe -column 0 -row $i -sticky nsew -weightx 1.0
            }
        } else {
            label $fr.lab$row -text [set panvar(Label,$row)] -width 8
            if {!$Nv_Priv(javaMode)} {
                grid columnconfigure $fr 0 -weight 100
                grid rowconfigure $fr $i -weight 100
                grid $fr.lab$row -in $fr -column 0 -row $i -sticky nsew
            } else {
                grid $fr.lab$row -column 0 -row $i -sticky nsew -weightx 1
            }
        }
        for {set field 0 } {$field < $nfields} {incr field} {
            set j [expr {$field+1}]
            entry $fr.entry${row}_$field -width 8  -bd 2 -relief sunken  -textvariable ${varnm}($row,$field)
            if {!$Nv_Priv(javaMode)} {
                grid columnconfigure $fr $j -weight 100
                grid $fr.entry${row}_$field -in $fr -column $j -row $i -sticky nsew
            } else {
                grid $fr.entry${row}_$field -column $j -row $i -sticky nsew -weightx 1
            }
            set panvar($row,$field) ""
            bind $fr.entry${row}_$field <Return> "NvGetPeakAnal $nm"
            if {!$Nv_Priv(javaMode)} {
                bind $fr.entry${row}_$field <KeyPress> "$nm.mbar.peak configure -bg Red"
            }
            if {[lindex $RowNames $row]=="Center"} {
                bind $fr.entry${row}_$field <Down> "nv_peak fold \$${varnm}(curr_list).\$${varnm}(curr_peak).[expr $field+1] down;NvUpdatePeakAnal $nm;nv_database sync"
                bind $fr.entry${row}_$field <Up> "nv_peak fold \$${varnm}(curr_list).\$${varnm}(curr_peak).[expr $field+1] up;NvUpdatePeakAnal $nm;nv_database sync"
            }
        }
    }
    label $nm.fr2.intlab -text Int. -width 4
    label $nm.fr2.vollab -text Vol. -width 4
    entry $nm.fr2.int -width 8  -relief sunken  -textvariable ${varnm}(int)
    add_tip $nm.fr2.int peakAnal.int "The peak intensity (maximum value)."
    entry $nm.fr2.vol -width 8  -relief sunken  -textvariable ${varnm}(vol)
    add_tip $nm.fr2.vol peakAnal.vol "The peak volume (This is not calculated during peak picking)."
    
    label $nm.fr2.currlist -textvariable ${varnm}(curr_list) -relief sunken
    
    pack $nm.fr2.intlab $nm.fr2.int $nm.fr2.vollab $nm.fr2.vol -side left
    pack $nm.fr2.currlist -side right
    
    bind $nm.fr2.int <Return> "NvUpdatePeakAnal $nm"
    bind $nm.fr2.vol <Return> "NvUpdatePeakAnal $nm"
    
    
    label $nm.fr3.commentLabel -text Comment -width 8
    entry $nm.fr3.comment -width 46 -relief sunken -textvariable ${varnm}(comment)
    bind $nm.fr3.comment <Return> "NvGetPeakAnal $nm"
    bind $nm.fr3.comment <KeyPress> "$nm.mbar.peak configure -bg Red"
    
    add_tip $nm.fr3.comment peakAnal.comment "The peak comment."
    pack $nm.fr3.commentLabel $nm.fr3.comment -side left
    bind $nm.fr3.comment <Return> "NvGetPeakAnal $nm"
    if {!$Nv_Priv(javaMode)} {
        
        set child [lindex [grid slaves $fr] 0]
        #	tkwait visibility $child
        update
        set incr [winfo height $child]
        set height [winfo height $fr]
        set width [winfo width $fr]
        $canvas config -scrollregion "0 0 $width $height"
        $canvas config -yscrollincrement $incr
        if {$height > 4 * $incr } {
            set height [expr 4 * $incr]
        }
        $canvas config -width $width -height $height
        wm maxsize $nm 600 700
        wm minsize $nm 180 160
        
    }
}

proc NvPeakIncr {varnm incrVal} {
    upvar #0 $varnm panvar
    
    set iList $panvar(curr_list)
    set iPeak [expr {$panvar(curr_peak)+$incrVal}]
    set index [NvPeakCheckIndex $iList $iPeak $incrVal]
    if {$index >= 0} {
        set panvar(curr_peak) [eval nv_peak idnum $iList.$index]
    }
}

proc NvPeakCheckIndex {iList iPeak incrVal} {
    set idlast [nv_peak idlast $iList]
    if {$iPeak < 0} {return {} }
    while {1} {
        if {$iPeak > $idlast} {
            return -1
        }
        if {![catch "nv_peak elem index $iList.$iPeak" index]} {
            break
        }
        incr iPeak $incrVal
        if {$iPeak == 0} {return -1}
    }
    return $index
}

proc NvPeakShiftLabel {args} {
    global Nv_Priv
    
    set narg [llength $args]
    if {$narg>0} {
        set nm [lindex $args 0]
    } else {
        set nm $Nv_Priv(peakAnal)
    }
    if {$narg>1} {
        set labelField [lindex $args 1]
    } else {
        set labelField $nm.fr1.data.0.0
    }
    if {$narg>2} {
        set dir [lindex $args 2]
    } else {
        set dir 1
    }
    set varnm [NvVarnm $nm]
    upvar #0 $varnm panvar
    set curr_list $panvar(curr_list)
    set labels [nv_peak label $curr_list]
    set ndim [llength $labels]
    incr panvar(labelIndex) $dir
    if {$panvar(labelIndex) < 0} {
        set panvar(labelIndex) 0
    }
    set nVals [llength $panvar(labelVal,0)]
    if {$panvar(labelIndex) >= $nVals} {
        set panvar(labelIndex) $nVals
    }
    for {set field 0} {$field < $ndim} {incr field} {
        set fldnm [lindex $labels $field]
        set panvar(0,$field) [lindex $panvar(labelVal,$field) $panvar(labelIndex)]
        
    }
    
    
}
proc NvPeakDelete {nm} {
    set varnm [NvVarnm $nm]
    upvar #0 $varnm panvar
    nv_peak delete $panvar(curr_list).$panvar(curr_peak)
    $nm.mbar.delstatus config -fg red
    $nm.mbar.delstatus config -highlightcolor red
}
proc NvPeakUnDelete {nm} {
    set varnm [NvVarnm $nm]
    upvar #0 $varnm panvar
    nv_peak undelete $panvar(curr_list).$panvar(curr_peak)
    $nm.mbar.delstatus config -fg black
    $nm.mbar.delstatus config -highlightcolor black
}

proc NvPeakFlipStatus {nm} {
    set varnm [NvVarnm $nm]
    upvar #0 $varnm panvar
    set status [nv_peak status $panvar(curr_list).$panvar(curr_peak)]
    if {$status>=0} {
        nv_peak delete $panvar(curr_list).$panvar(curr_peak)
        $nm.mbar.delstatus config -fg red
        $nm.mbar.delstatus config -highlightcolor red
    } else {
        nv_peak undelete $panvar(curr_list).$panvar(curr_peak)
        $nm.mbar.delstatus config -fg black
        $nm.mbar.delstatus config -highlightcolor black
    }
    
}

proc NvPeakFlipLock {nm} {
    global Nv_Priv
    set varnm [NvVarnm $nm]
    upvar #0 $varnm panvar
    set status [nv_peak elem flag0 $panvar(curr_list).$panvar(curr_peak)]
    if {$status==0} {
        nv_peak elem flag0 $panvar(curr_list).$panvar(curr_peak) 1
        $nm.mbar.locked config -bitmap @$Nv_Priv(image,lock)
    } else {
        nv_peak elem flag0 $panvar(curr_list).$panvar(curr_peak) 0
        $nm.mbar.locked config -bitmap @$Nv_Priv(image,unlock)
    }
    
}

proc ShowPeakAnal args {
    global Nv_Priv
    set narg [llength $args]
    if {$narg>0} {
        set nm [lindex $args 0]
    } else {
        set nm $Nv_Priv(peakAnal)
    }
    wm deiconify $nm
    update
}

proc NvSetPeakAnal {args} {
    global Nv_Priv
    set narg [llength $args]
    if {$narg>0} {
        set nm [lindex $args 0]
    } else {
        set nm $Nv_Priv(peakAnal)
    }
    set varnm [NvVarnm $nm]
    
    global curr_list curr_peak
    upvar #0 $varnm panvar
    set panvar(curr_list) $curr_list
    set panvar(curr_peak) $curr_peak
    NvUpdatePeakAnal
}



proc NvUpdatePeakAnal args {
    global Nv_Priv
    
    set narg [llength $args]
    if {$narg>0} {
        set nm [lindex $args 0]
    } else {
        set nm $Nv_Priv(peakAnal)
    }
    set varnm [NvVarnm $nm]
    
    global curr_list curr_peak
    upvar #0 $varnm panvar
    
    if {$panvar(curr_list)==""} {
        return
    }
    if {$panvar(curr_list)=="NULL"} {
        return
    }
    
    if {[llength [nv_peak lists]] < 1} {
        return
    }
    
    
    if {$panvar(curr_peak)<0} {
        set panvar(curr_peak) 0
    }
    wm title $nm   $panvar(curr_list)
    
    if {$panvar(curr_peak)<0} {set panvar(curr_peak) 0}
    
    set idlast [nv_peak idlast $panvar(curr_list)]
    
    if {$idlast <= 0} {return}
    
    if {$panvar(curr_peak)>$idlast} {set panvar(curr_peak) [expr $idlast]}
    
    set curr_peak $panvar(curr_peak)
    set curr_list $panvar(curr_list)
    
    if {[catch "eval nv_peak status $curr_list.$curr_peak"]} {
        set blankMode 1
    } else {
        set blankMode 0
    }
    
    
    set nrows $panvar(nRows)
    set start $panvar(start)
    
    if {$narg>2} {
        set cmd [lindex $args 1]
        set fstart [lindex $args 2]
        
        switch $cmd {
            scroll {
                incr start $fstart
            }
            moveto {
                set start [expr round($fstart*$nrows)]
            }
        }
    }
    
    set nfields 4
    set labels [nv_peak label $curr_list]
    set ndim [llength $labels]
    if {$blankMode} {set ndim 0}
    
    for {set i 0 } {$i < $panvar(nRows)} {incr i} {
        set lab  $panvar(Label,[expr $i+$start])
        set typ  $panvar(Type,[expr $i+$start])
        for {set field 0 } {$field < $nfields} {incr field} {
            if {$field<$ndim} {
                set fldnm [lindex $labels $field]
                if {$typ==".L"} {
                    set panvar(labelVal,$field) [nv_peak elem $fldnm$typ $panvar(curr_list).$panvar(curr_peak)]
                    set panvar(labelIndex) 0
                    set panvar($i,$field) [lindex $panvar(labelVal,$field) 0]
                } elseif {$typ==".R"} {
                    if {![catch "nv_atom elem rname $panvar([expr {$i-1}],$field)" result]} {
                        set panvar($i,$field) $result
                    } else {
                        set panvar($i,$field) ""
                    }
                } else {
                    set panvar($i,$field) [nv_peak elem $fldnm$typ $panvar(curr_list).$panvar(curr_peak)]
                    
                }
                
            } else  {
                set panvar($i,$field) ""
            }
        }
    }
    if {$blankMode} {
        set panvar(nLabels) 1
        foreach field "int vol comment" {
            set panvar($field) ""
        }
    } else {
        
        # begin edited code to correctly represent the number of labels
        # when the field containing the multiple labels is not the first
        # field
        set panvar(nLabels) 1
        for {set field 0} {$field < $nfields} {incr field} {
            if {($field<$ndim) &&([set nlabels [llength $panvar(labelVal,$field)]] > $panvar(nLabels))} {
                set panvar(nLabels) $nlabels
            }
        }
        
        # end edited code
        
        
        set panvar(int) [nv_peak elem int $panvar(curr_list).$panvar(curr_peak)]
        set panvar(vol) [nv_peak elem vol $panvar(curr_list).$panvar(curr_peak)]
        set panvar(comment) [nv_peak elem comment $panvar(curr_list).$panvar(curr_peak)]
        set status [nv_peak status $panvar(curr_list).$panvar(curr_peak)]
        if {$status>=0} {
            $nm.mbar.delstatus config -fg black
            $nm.mbar.delstatus config -highlightcolor black
        } else {
            $nm.mbar.delstatus config -fg red
            $nm.mbar.delstatus config -highlightcolor red
        }
        set locked [nv_peak elem flag0 $panvar(curr_list).$panvar(curr_peak)]
        if {$locked} {
            $nm.mbar.locked config -bitmap @$Nv_Priv(image,lock)
        } else {
            $nm.mbar.locked config -bitmap @$Nv_Priv(image,unlock)
        }
        if {!$Nv_Priv(javaMode)} {
            nv_peak sho $panvar(curr_list).$panvar(curr_peak)
        }
        if {[winfo exists $Nv_Priv(peakId)]} {
            NvIdPeak
        }
    }
    $nm.mbar.peak configure -bg LightGray
    return 0
}

proc NvGetPeakAnal {nm} {
    global curr_list curr_peak PDIM_MAX
    wm title $nm  $curr_list
    if {[catch "eval nv_peak status $curr_list.$curr_peak"]} {return}
    set varnm [NvVarnm $nm]
    
    global $varnm c
    upvar #0 $varnm panvar
    
    set nrows [set ${varnm}(nRows)]
    
    set nfields $PDIM_MAX
    for {set i 0 } {$i < $nrows} {incr i} {
        set typ  [set panvar(Type,$i)]
        set labels [nv_peak label $panvar(curr_list)]
        set ndim [llength $labels]
        for {set field 0 } {$field < $ndim} {incr field} {
            set fldnm [lindex $labels $field]
            if {$typ==".L"} {
                if {$panvar(labelIndex) >= [llength $panvar(labelVal,$field)]} {
                    lappend panvar(labelVal,$field) $panvar($i,$field)
                } else {
                    set panvar(labelVal,$field) \
                    [lreplace $panvar(labelVal,$field) $panvar(labelIndex) $panvar(labelIndex) $panvar($i,$field)]
                }
                set newLabels ""
                foreach labelVal $panvar(labelVal,$field) {
                    if {$labelVal != {}} {
                        lappend newLabels $labelVal
                        
                    }
                    
                }
                
                nv_peak elem $fldnm$typ $panvar(curr_list).$panvar(curr_peak) $newLabels
                
            } elseif {($typ != ".R") } {
                nv_peak elem $fldnm$typ $panvar(curr_list).$panvar(curr_peak) [set panvar($i,$field)]
            }
        }
    }
    
    # begin edited code to correctly represent the number of labels
    # when the field containing the multiple labels is not the first
    # field
    
    set panvar(nLabels) 1
    for {set field 0} {$field < $nfields} {incr field} {
        if {($field<$ndim) &&([set nlabels [llength $panvar(labelVal,$field)]] > $panvar(nLabels))} {
            set panvar(nLabels) $nlabels
        }
    }
    
    
    # end edited code
    
    nv_peak elem int $panvar(curr_list).$panvar(curr_peak) [set panvar(int)]
    nv_peak elem vol $panvar(curr_list).$panvar(curr_peak) [set panvar(int)]
    nv_peak elem comment $panvar(curr_list).$panvar(curr_peak) [set panvar(comment)]
    $nm.mbar.peak configure -bg LightGray
    nv_database sync
}

proc NvPeakGetList {peak} {
    set dot [string first "." $peak]
    if {$dot<0} {
        return $peak
    } else {
        set list [string range $peak 0 [expr $dot-1]]
    }
    return $list
}

proc NvFillPeakAnalMenu {nm menu var} { ; #refresh the list of peak sets in $menu 
    $menu delete 0 end
    foreach list [nv_peak list] { ; # go through all lists in the database
        if {$list != ""} {
            $menu add radiobutton -label $list -variable $var -value $list -command "NvPeakAnalSelect $nm"
        }
    }
}

proc NvPeakAnalSelect {nm} {
    set varnm [NvVarnm $nm]
    global  Nv_Priv
    upvar #0 $varnm panvar
    
    set panvar(curr_peak) 0
    NvUpdatePeakRef $nm
    NvUpdatePeakAnal $nm
}

proc NvPeakPlotVolInt {} {
    global xyGraph
    Nv_PeakXYVolInt
    set xyGraph(xAxisBottom,label) Vol.
    set xyGraph(yAxisLeft,label)  Int.
    NvGraphDisplay xyGraph
}

proc NvPeakNavigate args {
    global Nv_Priv
    set narg [llength $args]
    if {$narg>0} { set nm [lindex $args 0] } else {set nm $Nv_Priv(peakAnal)}
}

proc NvPeakCompress {} {
    global Nv_Prefs
    if {!$Nv_Prefs(override,compact)} {
        set result [tk_messageBox -icon question -type yesno -message "Compress peak list? This will permanently remove any peaks marked for deletion."]
        if {$result=="no"} {
            return
        }
    }
    nv_peak compress
}

proc NvPeakDeleteList {list} {
    set result [tk_messageBox -icon question -type yesno -message "Delete the peak list\n named ${list}?\n  Once you do another peakpick this will be permanent!"]
    if {$result=="no"} {return}
    nv_peak name $list ""
}

proc NvPeaksWriteList {} {
    global curr_list Nv_Prefs
    if {$curr_list==""} {error "NvPeaksWriteList: Select a peak list first"}
    set lst [nv_peak name $curr_list]
    if {$Nv_Prefs(usedirs)} {
        set idir $Nv_Prefs(dir,rdpeaks)
    } else {
        set idir [pwd]
    }
    set filename [tk_getSaveFile -title "NMRView PeakList" -initialdir $idir]
    if {$filename=={}} {
        return
    }
    
    if {[lindex [split $filename .] 1] == "str"} {error "Attempting to save a peaklist to a file of type STAR"}
    writepks $lst $filename
}


proc NvPeakRegister {widget} {
    global Nv_Priv
    if {[info exists Nv_Priv(peakWidgets)]} {
        if {[lsearch $Nv_Priv(peakWidgets) $widget] >= 0} {
            return
        }
    }
    lappend Nv_Priv(peakWidgets) $widget
    
}

proc NvPeakPartners {} {
    global curr_list curr_peak
    clear
    foreach list [nv_peak lists] {
        set nmatch 0
        set template ""
        set search ""
        foreach label [nv_peak labels $curr_list] tol [nv_peak idtol $curr_list] {
            if {[string match *C* $label]} {
                continue
            }
            if {[lsearch [nv_peak labels $list] $label] >= 0} {
                incr nmatch
                lappend template $label
                lappend template $tol
                lappend search [eval nv_peak elem $label.P $curr_list.$curr_peak]
            }
        }
        if {$nmatch > 1} {
            eval nv_peak template $list $template
            foreach peak [eval nv_peak find $list $search] {
                puts -nonewline [format "%-18s " $peak]
                foreach label [nv_peak labels $list] {
                    set assignment [eval nv_peak elem $label.L $peak]
                    puts -nonewline [format "%-8s " $assignment]
                }
                puts ""
            }
        }
    }
    tkConPrompt
}
