# Copyright (c) 1995 Merck and Co., Inc.
#       Whitehouse Station, NJ USA
#          All Rights Reserved

proc NvMkInfo { } {
	global Nv_Priv
	toplevel .info
    wm geometry .info +300+200
    canvas .info.c -width 400 -height 150 -bg white
    pack .info.c
    set img [image create photo -file [file join $Nv_Priv(imagedir) nmrviewlogo2.gif]]
   .info.c create image 200 0 -image $img -anchor n
    set text "Bruce A. Johnson\nCopyright 1994-2001 Merck And Co.\nWhitehouse Station, NJ USA"
   .info.c create text 200 100 -text $text -justify center -anchor n -fill red
    bind .info.c <ButtonRelease-1> "destroy .info"
    after 5000 destroy .info
    raise .info
    update
}

proc tkAboutDialog {} {
	global Nv_Priv
	toplevel .nv_about
    wm geometry .nv_about +20+20
    canvas .nv_about.c -width 400 -height 150 -bg white
    pack .nv_about.c
    set img [image create photo -file [file join $Nv_Priv(imagedir) nmrviewlogo2.gif]]
   .nv_about.c create image 200 0 -image $img -anchor n
    set text "Bruce A. Johnson\nCopyright 1994-2001 Merck And Co.\nWhitehouse Station, NJ USA"
   .nv_about.c create text 200 100 -text $text -justify center -anchor n -fill red
    update
    bind .nv_about.c <ButtonRelease-1> "destroy .nv_about"
}


proc NvMkCntrlPanel {} {
    global Nv_Priv Nv_Prefs tip_priv

    frame .mbar -relief raised -bd 2
    frame .fr1 
    entry .cmdlin  -textvariable cmdlin

    pack .mbar -side top -fill x 
    wm geometry . +0+20
    
    
    menubutton .mbar.file -text File -underline 0 \
    -menu .mbar.file.menu
    add_tip .mbar.file mbar.file "File Menu:\n\n\
Prefs: Open a panel to set NMRView preferences.\n\n\
StarEditor: Open a Star File Editor.\n\n\
Show Console: Open a console for command line input/output.\n\n\
Hide Console: Hide console for command line input/output.\n\n\
Save State: Save current state to file .nmrview.\n\n
Load State: Load current state from file .nmrview.\n\n
Quit: Quit NMRView."
    
    
    menubutton .mbar.datasets -text Dataset -underline 0 \
    -menu .mbar.datasets.menu
    add_tip .mbar.datasets mbar.datasets "Dataset Menu:\n\n\
Open Dataset: Display a file selection panel to open datasets.\n\n\
Open and Draw Dataset: Display a file selection panel to open and draw datasets.\n\n\
Manage Datasets: Display a panel to manage (remove and reference) datasets.\n\n
Open Varian Fid: Display a file selection panel to open Varian FIDs.\n\n
Open Bruker Fid: Display a file selection panel to open Bruker FIDs.\n\n
AutoProcess Varian FID: Automatically process a Varian FID.\n\n
Convert Varian Phasefile: Display a file selection panel to convert Varian Phasefiles."

    menubutton .mbar.windows -text Windows -underline 0 \
    -menu .mbar.windows.menu
    add_tip .mbar.windows mbar.windows "Windows Menu:\n\n\
Add: Display a panel to use to create new spectral windows.\n\n\
Manage: Display a panel to manage spectral windows.\n\n
CBCA: Display a panel for analysis of 3D CBCA type experiments.\n\n
Strips: Display a panel to display spectral strip plots."

    menubutton .mbar.assign -text Assign -underline 0 \
    -menu .mbar.assign.menu
    add_tip .mbar.assign mbar.assign "Assign Menu:\n\n\
Peaks: Display a panel to manage peak lists.\n\n
Atoms: Display a panel to manage chemical shift assignments.\n\n
Sequence: Display a panel to display aa sequence and to do CSI analysis.\n\n
Noes Display a panel to manage noe lists."

    menubutton .mbar.analysis -text Analysis -underline 0 \
    -menu .mbar.analysis.menu
    add_tip .mbar.analysis mbar.analysis "Analysis Menu:\n\n\
Vector: Display vector analysis panel for processing, phaseing etc.\n\n\
XY: Display XY graphics panel for data display and curve fitting.\n\n
Rate: Display Rate analysis panel for data display and curve fitting.\n\n
HetNOE"

    menubutton .mbar.molecules -text Molecules -underline 0 \
    -menu .mbar.molecules.menu
    add_tip .mbar.molecules mbar.molecules "Molecules Menu:\n\n\
Read AA Sequence (from text file).\n\n\
Read PDB File.\n\n
MolViewer: Open 3D Molecular Graphics Viewer.\n\n
Ramachandran: Display a XY graph of Ramachandran plot."

    menubutton .mbar.help -text Help -underline 0 \
    -menu .mbar.help.menu
    pack .mbar.file .mbar.datasets .mbar.windows .mbar.assign .mbar.analysis .mbar.molecules -side left
    pack .mbar.help -side right

    menu .mbar.file.menu -tearoff 0
    .mbar.file.menu add command -label Prefs  -command "Preferences_Dialog .pref2"
	.mbar.file.menu add command -label "Read Star File" \
	 -command "if !\[NvGetFile starRead\] {NvStarShowCodes .starEdit \$NvStar(dataCode) duck}"
	.mbar.file.menu add command -label "Write Star File"  -command {NvSaveFile starWrite}
	.mbar.file.menu add command -label "Fetch Star File" \
	  -command NvStarFetch
    .mbar.file.menu add command -label StarEditor  -command  {NvStarShowCodes .starEdit $NvStar(dataCode) duck)}
    .mbar.file.menu add command -label {Show Console}  -command "tkcon show"
    .mbar.file.menu add command -label {Hide Console}  -command "tkcon hide"
    .mbar.file.menu add command -label {Save State}  -command "NvStateSave"
    .mbar.file.menu add command -label {Load State}  -command "NvStateLoad"
    .mbar.file.menu add command -label Quit  -command exit

    menu .mbar.datasets.menu -tearoff 0
    .mbar.datasets.menu add command -label "Open Datasets"  -command {NvShowFileBox datasets}
    .mbar.datasets.menu add command -label "Open and Draw Dataset"  -command {NvShowFileBox datasetsdraw}
    .mbar.datasets.menu add command -label "Manage Datasets"  -command "NvMkDatasetMngr"
    .mbar.datasets.menu add command -label "Add Varian Fid"  -command {NvGetFile vnmr}
    .mbar.datasets.menu add command -label "Add Bruker Fid"  -command {NvGetFile uxnmr}
    .mbar.datasets.menu add command -label "AutoProcess VNMR FID"  -command {NvGetFile vnmr2d}
    .mbar.datasets.menu add command -label "Convert Varian Phasefile"  -command {NvGetFile vnmrp}

    menu .mbar.windows.menu -tearoff 0
    .mbar.windows.menu add command -label Add -command "NvMkWindowAdd $Nv_Priv(windowAdd)"
    .mbar.windows.menu add command -label Manage -command "NvMkWindowList $Nv_Priv(windowList)"
    .mbar.windows.menu add command -label Strips  -command "NvMkStrips .strips"
    .mbar.windows.menu add command -label Strips2  -command "NvMkStrips2 .strips2"
    .mbar.windows.menu add command -label NvAssign -command "cbca .nvassign"

    menu .mbar.assign.menu -tearoff 0
    .mbar.assign.menu add command -label Peaks -command "Nv_ShowPeakAnal $Nv_Priv(peakAnal)"
    .mbar.assign.menu add command -label Atoms  -command "Nv_ShowAssignPan $Nv_Priv(assignPanel)"
    .mbar.assign.menu add command -label Sequence -command "Nv_SeqDisplay .seq"
    .mbar.assign.menu add command -label NOEs -command "Nv::Noe::ShowAnal $Nv_Priv(noeAnal)"

    menu .mbar.analysis.menu -tearoff 0
    .mbar.analysis.menu add command -label Vector -command "Nv_MkVecGraph $Nv_Priv(vecGraph)"
    .mbar.analysis.menu add command -label XY -command "NvGraphDisplay xyGraph"
    .mbar.analysis.menu add command -label "Rate Analysis" -command "NvRateMakeControl $Nv_Priv(rateAnal)"
    .mbar.analysis.menu add command -label "HetNOE Analysis" -command "NvMkhetnoe .hetNOE"
    .mbar.analysis.menu add command -label "HNHA Analysis" -command "NvMkHNHA .hnha"
    .mbar.analysis.menu add command -label "Write Modelfree" -command "NvMkModelfree .modelfree"


    menu .mbar.molecules.menu -tearoff 0
    .mbar.molecules.menu add cascade -label "Read Topology"  -menu .mbar.molecules.menu.topo 
	menu .mbar.molecules.menu.topo  -tearoff 0
    .mbar.molecules.menu.topo add command -label "Sequence File"  -command {NvGetFile seq}
    .mbar.molecules.menu.topo add command -label "PDB File (using library)"  -command {NvGetFile pdb}
    .mbar.molecules.menu.topo add command -label "PDB File"  -command {NvGetFile pdbx}
    .mbar.molecules.menu.topo add command -label "PSF File"  -command {NvGetFile xpsf}
    .mbar.molecules.menu add cascade -label "Read Coordinates"  -menu .mbar.molecules.menu.coord 
	menu .mbar.molecules.menu.coord -tearoff 0
    .mbar.molecules.menu.coord add command -label "PDB File"  -command {NvGetFile xyz}
    .mbar.molecules.menu.coord add command -label "PDB File (multiple files)"  -command {NvGetFile mxyz}
    .mbar.molecules.menu.coord add command -label "PDB File (representative)"  -command {NvGetFile rxyz}
    .mbar.molecules.menu add cascade -label "Analysis"  -menu .mbar.molecules.menu.anal 
	menu .mbar.molecules.menu.anal -tearoff 0
    .mbar.molecules.menu.anal add command -label MolViewer -command "Nv_MkMol $Nv_Priv(molViewer).c Mol1"
    .mbar.molecules.menu.anal add command -label Ramachandran -command "rama xyRama;NvGraphDisplay xyRama .xyRama"
    .mbar.molecules.menu.anal add command -label RRMSD -command "rrmsd xyRRMSD;NvGraphDisplay xyRRMSD .xyRRMSD"
    
    menu .mbar.help.menu -tearoff 0 -tearoff 0
    .mbar.help.menu add command -label "About" -command tkAboutDialog
    .mbar.help.menu add command -label "User's Manual (Internal Viewer)" -command [list InitHelp  $Nv_Prefs(helpfile)]
    .mbar.help.menu add command -label "User's Manual (External Viewer)" -command "set helppid \[exec $Nv_Prefs(helpprogram) $Nv_Prefs(helpfile) &\]"
    .mbar.help.menu add checkbutton -label BalloonTips -variable tip_priv(tips_enabled)
    set tip_priv(tips_enabled) 0
    wm minsize . 1 1
    catch {console hide}
    NvMkInfo
    update
	NvConsoleShow
}
proc NvExecCmdLine {} {
  global cmdlin
  set result [ uplevel #0 [.cmdlin get]]
  puts $result
  set len [string length $result]
  if {$len>40} { set result [string range $result 0 40]... }
  NvUpdateHistory
  NvUpdateHistory $result
  set cmdlin ""
}

proc NvConsoleShow {} {
set conwin .tkcon
if {![winfo exists $conwin]} {
	tkConInit
	set screenheight [winfo screenheight $conwin]
	wm geometry $conwin 80x10+1+200
	update idletasks
	set height [winfo height $conwin]
	set y [expr $screenheight-$height-21]
	set x 1
	puts "$height $screenheight $x $y"
	wm geometry $conwin 80x10+$x+$y
	tkcon attach main
	update
}
wm deiconify $conwin
raise $conwin

}


proc NvMkNVConsole {} {
	global Nv_Priv
    pack .cmdlin -side bottom -fill x
    pack .fr1 -after .cmdlin -side bottom  -fill both
    bind .cmdlin <Return> NvExecCmdLine
    bind .cmdlin <Control-u> {set cmdlin ""}
    canvas .fr1.c -width 380 -height 100
    pack .fr1.c
    set img [image create photo -file [file join $Nv_Priv(imagedir) nmrviewlogo2.gif]]
   .fr1.c create image 0 0 -image $img -anchor nw
    bind .fr1.c <ButtonRelease-1> "destroy .fr1.c;NvMkHistoryBox"

}



proc NvMkHistoryBox {{nm .fr1}} {
    frame $nm.fn1
    frame $nm.fn2
#   pack $nm.fn2 -side bottom -fill x -expand yes
    pack $nm.fn2 -side bottom -fill x
    pack $nm.fn1 -side bottom -after $nm.fn2 -fill both -expand yes
    
    listbox $nm.fn1.history \
    -yscrollcommand "$nm.fn1.yscroll set "  \
    -xscrollcommand "$nm.fn2.xscroll set "
    
    pack $nm.fn1.history -side left -fill both -expand yes
    
    scrollbar $nm.fn1.yscroll -command "$nm.fn1.history yview"
    pack $nm.fn1.yscroll -side right -fill y
    
    scrollbar $nm.fn2.xscroll -orient horizontal -command "$nm.fn1.history xview"
    pack $nm.fn2.xscroll -side bottom -fill x
    bind $nm.fn1.history  <ButtonRelease-1> {+set cmdlin [selection get]}
    bind $nm.fn1.history  <Double-ButtonRelease-1> NvExecCmdLine
}

proc NvUpdateHistory {args} {
    if {[winfo exists .fr1.c]} {
        destroy .fr1.c
        NvMkHistoryBox
    }


    set nm .fr1.fn1.history
    global historysize
    set nsize 50
    if {[info exists historysize]} {set nsize $historysize}
    if {[llength $args]>0} {
    	$nm insert end $args
    } else {
    	$nm insert end [.cmdlin get]
    }
    if {[$nm size]>$nsize} {$nm delete 0}
    $nm see [expr [$nm size]-1]
}
